#!/usr/bin/python3
import sys
from insights_protocol import StepBase, ExchangeDataHolder
from concurrent.futures.thread import ThreadPoolExecutor

class MultiThreaded(StepBase):
    
    threadpool = ThreadPoolExecutor( max_workers=5 )
    
    # Called for every input
    async def invoke(self, exchange_data_holder: ExchangeDataHolder) -> ExchangeDataHolder:
        return await self.event_loop.run_in_executor(self.threadpool, self.doInvoke, exchange_data_holder)
    
    def doInvoke(self, exchange_data_holder: ExchangeDataHolder) -> ExchangeDataHolder:
        print("INFO: doInvoke")
        return exchange_data_holder
        
if __name__ == "__main__":
    input = sys.stdin.buffer
    output = sys.stdout.buffer
    sys.stdout = sys.stderr  # make any print in code going to stderr
    MultiThreaded(input,output).process_stream()
