#!/usr/bin/python
import sys
from bson.json_util import dumps, loads, RELAXED_JSON_OPTIONS
from datetime import datetime, timezone

for line in sys.stdin:
    input_data_holder = loads(line)
    for doc in input_data_holder['documents']:
        metadata = doc.get('metaData') or {}
        doc['metaData'] = metadata
        metadata['processedAt'] = datetime.now(tz=timezone.utc)
    print(dumps(input_data_holder, json_options=RELAXED_JSON_OPTIONS))
