#!/usr/bin/python3
from insights_protocol import StepBase, ExchangeDataHolder

class PullUpPayload(StepBase):
    
    async def invoke(self, exchange_data_holder: ExchangeDataHolder) -> ExchangeDataHolder:
        def extract_payload( doc: dict ) -> dict:
            new_doc = doc.get('payload') or {}
            if '_id' in doc and isinstance(new_doc, type({})):
                new_doc['_id'] = doc['_id']
            return new_doc
        document_payloads = [extract_payload(doc) for doc in exchange_data_holder.documents]
        return exchange_data_holder._replace(documents=document_payloads)
        
if __name__ == "__main__":
    input = sys.stdin.buffer
    output = sys.stdout.buffer
    sys.stdout = sys.stderr  # make any print in code going to stderr
    PullUpPayload(input, output).process_stream()
